--I know, this is such a spaghetti code... but this is because of my stubbornnes of including Type 64 as conversion kit, lol

function WeaponFactoryTweakData:double_forbid( mod_one, mod_two ) 
    if self.parts[mod_one] and self.parts[mod_two] then
        self.parts[mod_one].forbids = self.parts[mod_one].forbids or {}
        table.insert(self.parts[mod_one].forbids, mod_two)
        self.parts[mod_two].forbids = self.parts[mod_two].forbids or {}
        table.insert(self.parts[mod_two].forbids, mod_one)
    end
end

Hooks:PostHook( WeaponFactoryTweakData, "init", "HowaModInit", function(self)
	
	--Bipod compatibility
	self.parts.wpn_fps_ass_howa_b_para.forbids = { "wpn_fps_ass_howa_t89_bipod" }
	
	--Bayonet compatibility
	self.parts.wpn_fps_ass_howa_bayonet.adds = { "wpn_fps_ass_howa_t89_flashhider" } --bayonet installed on top of default flashhider
	self:double_forbid("wpn_fps_ass_howa_b_para", "wpn_fps_ass_howa_bayonet")	
	
	
	--making t89 standard mag doesnt have stat and doesnt appear on customization
	self.parts.wpn_fps_ass_howa_t89_mag.stats = nil
	self.parts.wpn_fps_ass_howa_t89_mag.pcs = nil
	
	
	--[[T89 and T64 parts compatibility]]
	self.parts.wpn_fps_ass_howa_s_wrapped.requires  = { "wpn_fps_ass_howa_t64_body" } --T64 attachment only
	self.parts.wpn_fps_ass_howa_m_supido.requires  = { "wpn_fps_ass_howa_t89_body" } --T89 attachment only
	self.parts.wpn_fps_ass_howa_m_para.requires  = { "wpn_fps_ass_howa_t89_body" } --T89 attachment only
	self.parts.wpn_fps_ass_howa_s_skeletal.requires  = { "wpn_fps_ass_howa_t89_body" } --T89 attachment only
	
	
	--[[T64 Conversion Kit changes]]
	if BeardLib.Utils:FindMod("WeaponLib") then
		self.parts.wpn_fps_ass_howa_t64_body.override_weapon = { --animation changes
			use_stance = "howa_64",
			weapon_hold = "ak47",			
			animations = {
				reload_name_id = "galil",
				recoil_steelsight = true
			},
			fire_mode_data = {
				fire_rate = 60 / 500
			}
		}
		self.parts.wpn_fps_ass_howa_t64_body.override_weapon_add = { --reload timer changes
			timers = { reload_not_empty = 0.55, reload_empty = 0.65	}
		}
	else --fallback code for non-weaponlib user
		self.parts.wpn_fps_ass_howa_t64_body.weapon_stance_override  = { bm_w_howa = "howa_64" }
        self.parts.wpn_fps_ass_howa_t64_body.weapon_hold_override = { bm_w_howa = "ak47" }
        self.parts.wpn_fps_ass_howa_t64_body.weapon_reload_override = { bm_w_howa = "galil" }
	end
	
	self.parts.wpn_fps_ass_howa_t64_body.override = { --weapon part changes
		wpn_fps_ass_howa_t89_barrel = { unit = "units/mods/weapons/wpn_fps_ass_howa_t64/wpn_fps_ass_howa_t64_barrel", a_obj = "a_b_t64" },
		wpn_fps_ass_howa_t89_flashhider = { unit = "units/mods/weapons/wpn_fps_ass_howa_t64/wpn_fps_ass_howa_t64_flashhider"},
		wpn_fps_ass_howa_t89_fg = { unit = "units/mods/weapons/wpn_fps_ass_howa_t64/wpn_fps_ass_howa_t64_fg" },
		wpn_fps_ass_howa_t89_bipod = { unit = "units/mods/weapons/wpn_fps_ass_howa_t64/wpn_fps_ass_howa_t64_bipod" },
		wpn_fps_ass_howa_t89_stock = { unit = "units/mods/weapons/wpn_fps_ass_howa_t64/wpn_fps_ass_howa_t64_stock" },
		--mag properties; an attempt to make bullet in mag, disappear properly
		wpn_fps_ass_howa_t89_mag = { 
			unit = "units/mods/weapons/wpn_fps_ass_howa_t64/wpn_fps_ass_howa_t64_mag",
			a_obj = "a_m_t64",
			bullet_objects = { amount = 10, prefix = "g_bullets_"},
			animations = { reload_not_empty = "reload_not_empty", reload = "reload" }
		},
		--para barrel properties
		wpn_fps_ass_howa_b_para = { 
			unit = "units/mods/weapons/wpn_fps_ass_howa_t64/wpn_fps_ass_howa_t64_b_para", 
			a_obj = "a_b_para_t64",
			stats = { damage = -25, spread = -3, recoil = 2, concealment = 2 } --stats override thru other part doesnt work for some reason. Override limitation? :(
		},
		--optic rail model and position change
		wpn_fps_ass_howa_body_rail = { 
			unit = "units/mods/weapons/wpn_fps_ass_howa_t64/wpn_fps_ass_howa_t64_rail",
			a_obj = "a_o_t64"
		}
	}
	
	
	--Gadget position override on t64 (so it doesnt clip with t64 bipod) || gadget position moved on t89 to make it look more natural
	local gadget_howa = {
		"wpn_fps_upg_fl_ass_smg_sho_peqbox",
		"wpn_fps_upg_fl_ass_smg_sho_surefire",
		"wpn_fps_upg_fl_ass_peq15",
		"wpn_fps_upg_fl_ass_laser",
		"wpn_fps_upg_fl_ass_utg",
		"wpn_fps_addon_ris",
	}
	for j, gadget_parts in ipairs(gadget_howa) do
		self.parts.wpn_fps_ass_howa_t89_body.override[gadget_parts] = { a_obj = "a_fl_t89" }
		self.parts.wpn_fps_ass_howa_t64_body.override[gadget_parts] = { a_obj = "a_fl_t64" }
	end
	
	
	
	--[[Optic Part Behaviour Code]]
	--t89 stance mod
	self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa = { translation = Vector3(0, 0, -2.75) }
	self.parts.wpn_fps_upg_o_aimpoint.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_aimpoint_2.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_docter.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_eotech.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_t1micro.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_cmore.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_acog.stance_mod.wpn_fps_ass_howa = { translation = Vector3(0, -2, -2.75) } -- original wpn_fps_ass_ak5 = {translation = Vector3(0, 0, -3.5)},
	self.parts.wpn_fps_upg_o_cs.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_eotech_xps.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_reflex.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_rx01.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_rx30.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_spot.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_bmg.stance_mod.wpn_fps_ass_howa = { translation = Vector3(0, 5, -2.75) } -- || original wpn_fps_ass_ak5 = {translation = Vector3(0, 7, -3.5)}
	self.parts.wpn_fps_upg_o_uh.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_fc1.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_specter.stance_mod.wpn_fps_ass_howa)
	
	self.parts.wpn_fps_upg_o_45rds.stance_mod.wpn_fps_ass_howa = { translation = Vector3(-2.125, 0, -13.125), rotation = Rotation(0, 0, -45) }
	self.parts.wpn_fps_upg_o_45rds_v2.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_45rds.stance_mod.wpn_fps_ass_howa)
	self.parts.wpn_fps_upg_o_45steel.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_45rds.stance_mod.wpn_fps_ass_howa)
	
	self.parts.wpn_fps_upg_o_xpsg33_magnifier.stance_mod.wpn_fps_ass_howa = { translation = Vector3(0, 0, -2.75) }
	self.parts.wpn_fps_upg_o_sig.stance_mod.wpn_fps_ass_howa = deep_clone(self.parts.wpn_fps_upg_o_xpsg33_magnifier.stance_mod.wpn_fps_ass_howa)

	
	local optic_howa = {
		"wpn_fps_upg_o_specter",
		"wpn_fps_upg_o_aimpoint",
		"wpn_fps_upg_o_aimpoint_2",
		"wpn_fps_upg_o_docter",	
		"wpn_fps_upg_o_eotech",	
		"wpn_fps_upg_o_t1micro",	
		"wpn_fps_upg_o_cmore",	
		"wpn_fps_upg_o_acog",	
		"wpn_fps_upg_o_cs",	
		"wpn_fps_upg_o_eotech_xps",	
		"wpn_fps_upg_o_reflex",	
		"wpn_fps_upg_o_rx30",	
		"wpn_fps_upg_o_rx01",
		"wpn_fps_upg_o_spot",
		"wpn_fps_upg_o_45rds",
		"wpn_fps_upg_o_45rds_v2",
		"wpn_fps_upg_o_xpsg33_magnifier",
		"wpn_fps_upg_o_sig",
		"wpn_fps_upg_o_bmg",
		"wpn_fps_upg_o_uh",
		"wpn_fps_upg_o_fc1",
		"wpn_fps_upg_o_45steel"
	}
	for k, sight_parts in ipairs(optic_howa) do
		--t64 higher optic point and angle
		--for any other optic sight
		if sight_parts ~= "wpn_fps_upg_o_acog" and sight_parts ~= "wpn_fps_upg_o_45rds" and sight_parts ~= "wpn_fps_upg_o_45rds_v2" and sight_parts ~= "wpn_fps_upg_o_xpsg33_magnifier" and sight_parts ~= "wpn_fps_upg_o_sig" and sight_parts ~= "wpn_fps_upg_o_45steel" then
			self.parts.wpn_fps_ass_howa_t64_body.override[sight_parts] = { 
				a_obj = "a_o_t64",
				stance_mod = { wpn_fps_ass_howa = {translation = Vector3(0, -2, -3.875)} }
			}
		end
		--acog
		if sight_parts == "wpn_fps_upg_o_acog" then
			self.parts.wpn_fps_ass_howa_t64_body.override[sight_parts] = {
				a_obj = "a_o_t64",
				stance_mod = { wpn_fps_ass_howa = {translation = Vector3(0, -4, -3.875)} }
			}
		end
		--acog v2 
		if sight_parts == "wpn_fps_upg_o_bmg" then
			self.parts.wpn_fps_ass_howa_t64_body.override[sight_parts] = {
				a_obj = "a_o_t64",
				stance_mod = { wpn_fps_ass_howa = {translation = Vector3(0, 3, -3.875)} }
			}
		end
		--45rds sight
		if sight_parts == "wpn_fps_upg_o_45rds" or sight_parts == "wpn_fps_upg_o_45rds_v2" or sight_parts == "wpn_fps_upg_o_45steel" then
			self.parts.wpn_fps_ass_howa_t64_body.override[sight_parts] = { 
				a_obj = "a_o_t64",
				stance_mod = { wpn_fps_ass_howa = {translation = Vector3(-0.375, 0, -13.5), rotation = Rotation(0, 0, -45)} }
			}
		end
		--xpsg33 sight
		if sight_parts == "wpn_fps_upg_o_xpsg33_magnifier" or sight_parts == "wpn_fps_upg_o_sig" then
			self.parts.wpn_fps_ass_howa_t64_body.override[sight_parts] = {
				stance_mod = { wpn_fps_ass_howa = {translation = Vector3(0, -2, -3.875) } }
			}
		end
		--optic rail added
		if sight_parts ~= "wpn_fps_upg_o_45rds" and sight_parts ~= "wpn_fps_upg_o_45rds_v2" and sight_parts ~= "wpn_fps_upg_o_xpsg33_magnifier" and sight_parts ~= "wpn_fps_upg_o_sig" and sight_parts ~= "wpn_fps_upg_o_45steel" then
			self.wpn_fps_ass_howa.adds[sight_parts] = {"wpn_fps_ass_howa_body_rail"} 
		end
	end
	
end )